<?php

namespace forge12\contactform7\CF7Captcha;

use forge12\contactform7\CF7Captcha\core\log\Log_Item;
use forge12\contactform7\CF7Captcha\core\log\Log_WordPress;

if (!defined('ABSPATH')) {
	exit;
}

/**
 * Class AvadaIPLog
 *
 * Handles IP log validation for Avada forms
 */
class AvadaIPLog
{
	/**
	 * AvadaIPLog constructor.
	 * Adds the spam protection validation filter
	 */
	public function __construct()
	{
		add_filter('fusion_form_demo_mode', [$this, 'validateSpamProtection'], 10, 1);
	}

	/**
	 * Validates the IP Address for spam protection
	 *
	 * @param mixed $value The filter value
	 * @return mixed The validated value
	 */
	public function validateSpamProtection($value)
	{
		// Validate the IP Address
		if (!IPValidator::getInstance()->validate()) {
			/*
			 * Add Log Entries
			 */
			$logItem = new Log_Item(
				__('Avada Form - IP Log', 'captcha-for-contact-form-7'),
				$_POST,
				'spam',
				'IP Address is blocked in AvadaIPLog.class.php'
			);
			Log_WordPress::store($logItem);

			die(wp_json_encode(ControllerAvada::get_results_from_message('error', 'spam')));
		}

		return $value;
	}
}
