<?php

namespace forge12\contactform7\CF7Captcha {

	use forge12\contactform7\CF7Captcha\core\log\Log_Item;
	use forge12\contactform7\CF7Captcha\core\log\Log_WordPress;

	if ( ! defined( 'ABSPATH' ) ) {
		exit;
	}

	/**
	 * Class Javascript Validator
	 * Responsible to handle the frontend of the Double OptIn
	 *
	 * @package forge12\contactform7\CF7Captcha
	 */
	class CF7_Javascript_Validator {
		private static $_instance = null;

		public static function get_instance(): CF7_Javascript_Validator {
			if ( self::$_instance == null ) {
				self::$_instance = new CF7_Javascript_Validator();
			}

			return self::$_instance;
		}

		/**
		 * Admin constructor.
		 */
		private function __construct() {
			add_filter( 'wpcf7_spam', [ $this, 'is_spam' ], 100, 2 );
		}

		public function is_spam($spam, $submission)
		{
			if($spam){
				return $spam;
			}

			$is_spam = !Timer::get_instance()->is_human();

			if($is_spam){
				/*
				 * Add Log Entries
				 */
				$Log_Item = new Log_Item(
					__('CF7 Form - Javascript Validator Log', 'captcha-for-contact-form-7'),
					$_POST,
					'spam',
					'Javascript validation failed in CF7_Browser_Validator.php');
				Log_WordPress::store($Log_Item);
			}

			return $is_spam;
		}
	}
}