<?php

namespace forge12\contactform7\CF7Captcha {

	use forge12\contactform7\CF7Captcha\core\log\Log_Item;
	use forge12\contactform7\CF7Captcha\core\log\Log_WordPress;

	if ( ! defined( 'ABSPATH' ) ) {
		exit;
	}

	/**
	 * Class Browser Validator
	 *
	 * @package forge12\contactform7\CF7Captcha
	 */
	class Comment_Browser_Validator {
		private static $_instance = null;

		public static function get_instance(): Comment_Browser_Validator {
			if ( self::$_instance == null ) {
				self::$_instance = new Comment_Browser_Validator();
			}

			return self::$_instance;
		}

		/**
		 * Admin constructor.
		 */
		private function __construct() {
			add_filter('preprocess_comment', array($this, 'is_spam'), 1);
		}

		public static function is_spam($commentdata)
		{
			/*
             * skip validation if user can moderate oder edit comments.
             */
			if (current_user_can('moderate_comments')) {
				return $commentdata;
			}

			$is_spam = Browser::get_instance()->is_crawler();

			if($is_spam){
				/*
                 * Add Log Entries
                 */
				$Log_Item = new Log_Item(__('Comment', 'captcha-for-contact-form-7'), $commentdata, 'spam', 'Browser validation failed in Comment_Browser_Validator.php');
				Log_WordPress::store($Log_Item);

				wp_die(__('Error: Spam', 'captcha-for-contact-form-7'));
			}

			return $commentdata;
		}
	}
}