<?php

namespace forge12\contactform7\CF7Captcha {

	use forge12\contactform7\CF7Captcha\core\log\Log_Item;
	use forge12\contactform7\CF7Captcha\core\log\Log_WordPress;

	if ( ! defined( 'ABSPATH' ) ) {
		exit;
	}

	/**
	 * Class Browser Validator
	 * Responsible to handle the frontend of the Double OptIn
	 *
	 * @package forge12\contactform7\CF7Captcha
	 */
	class Elementor_Browser_Validator {
		private static $_instance = null;

		public static function get_instance(): Elementor_Browser_Validator {
			if ( self::$_instance == null ) {
				self::$_instance = new Elementor_Browser_Validator();
			}

			return self::$_instance;
		}

		/**
		 * Admin constructor.
		 */
		private function __construct() {
			add_action('elementor_pro/forms/validation', array($this, 'is_spam'), 10, 2);
		}

		public function is_spam($record, $ajax_handler)
		{
			$is_spam = Browser::get_instance()->is_crawler();

			if($is_spam){

				$fields = $record->get('fields');

				/*
                 * Get the first field that is not hidden to show the error message to the visitor.
                 */
				$field_name = '';
				foreach ($fields as $key => $data) {
					if ($data['type'] != 'hidden') {
						$field_name = $key;
					}
				}

				/*
				 * Add Log Entries
				 */
				$Log_Item = new Log_Item(
					__('Elementor Form - Browser Log', 'captcha-for-contact-form-7'),
					$_POST,
					'spam',
					'Browser Validation failed in Elementor_Browser_Validator.php');
				Log_WordPress::store($Log_Item);

				$ajax_handler->add_error($field_name, esc_html__('You have been identified as spam, please try again later.', 'captcha-for-contact-form-7'));
			}

			return $is_spam;
		}
	}
}