<?php

namespace forge12\contactform7\CF7Captcha {

	use forge12\contactform7\CF7Captcha\core\log\Log_Item;
	use forge12\contactform7\CF7Captcha\core\log\Log_WordPress;

	if ( ! defined( 'ABSPATH' ) ) {
		exit;
	}

	/**
	 * Class Javascript Validator
	 *
	 * @package forge12\contactform7\CF7Captcha
	 */
	class GravityForms_Javascript_Validator {
		private static $_instance = null;

		public static function get_instance(): GravityForms_Javascript_Validator {
			if ( self::$_instance == null ) {
				self::$_instance = new GravityForms_Javascript_Validator();
			}

			return self::$_instance;
		}

		/**
		 * Admin constructor.
		 */
		private function __construct() {
			add_filter( 'gform_entry_is_spam', array( $this, 'is_spam' ), 10, 3 );
		}

		/**
		 * @param bool  $is_spam Indicates if the submission has been flagged as spam.
		 * @param array $form    The form currently being processed.
		 * @param array $entry   The entry currently being processed.
		 */
		public function is_spam( $is_spam, $form, $entry )
		{
			if(!Timer::get_instance()->is_human()){
				/*
				 * Add Log Entries
				 */
				$Log_Item = new Log_Item(
					__( 'Gravity Forms Form - JavaScript Validator', 'captcha-for-contact-form-7' ),
					$_POST,
					'spam',
					'JavaScript validation failed in GravityForms_Javascript_Validator.php' );
				Log_WordPress::store( $Log_Item );

				return true;
			}

			return $is_spam;
		}
	}
}