<?php

namespace forge12\contactform7\CF7Captcha {

	use forge12\contactform7\CF7Captcha\core\log\Log_Item;
	use forge12\contactform7\CF7Captcha\core\log\Log_WordPress;

	if ( ! defined( 'ABSPATH' ) ) {
		exit;
	}

	/**
	 * Class GravityForms_Rule_Validator
	 */
	class GravityForms_Rule_Validator {
		private static $_instance = null;

		public static function getInstance() {
			if ( self::$_instance == null ) {
				self::$_instance = new GravityForms_Rule_Validator();
			}

			return self::$_instance;
		}


		protected function __construct() {
			add_filter( 'gform_entry_is_spam', array( $this, 'is_spam' ), 10, 3 );
		}

		/**
		 * @param bool              $spam
		 * @param \WPCF7_Submission $submission
		 *
		 * @return mixed|void
		 */
		public function is_spam( $is_spam, $form, $entry ) {
			foreach ( $form['fields'] as $key => $form_field /** @var $form_field \GF_Field_Text */ ) {
				if ( ! isset( $_POST['input_'.$form_field->id]) || is_array($_POST['input_'.$form_field->id]) ) {
					continue;
				}

				$form_value = sanitize_text_field($_POST['input_'.$form_field->id]);

				if ( RulesHandler::getInstance()->isSpam( $form_value ) ) {
					$error_message = RulesHandler::getInstance()->getSpamMessage( '', '' );

					/*
					 * Add Log Entries
					 */
					$Log_Item = new Log_Item(
						__( 'GravityForms Form - Rule Validation failed', 'captcha-for-contact-form-7' ),
						$_POST,
						'spam',
						'Rule Validation failed in GravityForms_Rule_Validator.php: ' . $error_message );
					Log_WordPress::store( $Log_Item );
					return true;
				}
			}
			return $is_spam;
		}
	}
}