<?php

namespace forge12\contactform7\CF7Captcha {

	use forge12\contactform7\CF7Captcha\core\log\Log_Item;
	use forge12\contactform7\CF7Captcha\core\log\Log_WordPress;

	if ( ! defined( 'ABSPATH' ) ) {
		exit;
	}

	/**
	 * Class Browser Validator
	 *
	 * @package forge12\contactform7\CF7Captcha
	 */
	class Login_Browser_Validator {
		private static $_instance = null;

		public static function get_instance(): Login_Browser_Validator {
			if ( self::$_instance == null ) {
				self::$_instance = new Login_Browser_Validator();
			}

			return self::$_instance;
		}

		/**
		 * Admin constructor.
		 */
		private function __construct() {
			add_filter('wp_authenticate_user', array($this, 'is_spam'), 10, 2);
		}

		public function is_spam($user, $password)
		{
			$is_spam = Browser::get_instance()->is_crawler();

			if($is_spam){
				/*
				 * Add Log Entries
				 */
				$Log_Item = new Log_Item(
					__('WordPress Login - Browser Validator', 'captcha-for-contact-form-7'),
					$_POST,
					'spam',
					'Browser validation failed in Login_Browser_Validator.php');
				Log_WordPress::store($Log_Item);

				return new \WP_Error( '500', 'Browser Validation Error. Please try again.' );
			}

			return $user;
		}
	}
}