<?php

namespace forge12\contactform7\CF7Captcha {

	use forge12\contactform7\CF7Captcha\core\log\Log_Item;
	use forge12\contactform7\CF7Captcha\core\log\Log_WordPress;

	if ( ! defined( 'ABSPATH' ) ) {
		exit;
	}

	/**
	 * Class Browser Validator
	 *
	 * @package forge12\contactform7\CF7Captcha
	 */
	class Registration_Browser_Validator {
		private static $_instance = null;

		public static function get_instance(): Registration_Browser_Validator {
			if ( self::$_instance == null ) {
				self::$_instance = new Registration_Browser_Validator();
			}

			return self::$_instance;
		}

		/**
		 * Admin constructor.
		 */
		private function __construct() {
			add_filter('register_post', array($this, 'is_spam'), 10, 3);
		}

		public function is_spam($user, $email, $errors)
		{
			$is_spam = Browser::get_instance()->is_crawler();

			if($is_spam){
				/*
				 * Add Log Entries
				 */
				$Log_Item = new Log_Item(
					__('WordPress Registration - Browser Validator', 'captcha-for-contact-form-7'),
					$_POST,
					'spam',
					'Browser validation failed in Register_Browser_Validator.php');
				Log_WordPress::store($Log_Item);

				$errors->add('spam',  __( '<strong>Error:</strong> Browser not recognized.', 'captcha-for-contact-form-7' ) );
			}

			return $user;
		}
	}
}