<?php

namespace forge12\contactform7\CF7Captcha {

	use forge12\contactform7\CF7Captcha\core\log\Log_Item;
	use forge12\contactform7\CF7Captcha\core\log\Log_WordPress;

	if ( ! defined( 'ABSPATH' ) ) {
		exit;
	}

	/**
	 * Class Javascript Validator
	 *
	 * @package forge12\contactform7\CF7Captcha
	 */
	class WPForms_Javascript_Validator {
		private static $_instance = null;

		public static function get_instance(): WPForms_Javascript_Validator {
			if ( self::$_instance == null ) {
				self::$_instance = new WPForms_Javascript_Validator();
			}

			return self::$_instance;
		}

		/**
		 * Admin constructor.
		 */
		private function __construct() {
			add_filter( 'wpforms_process_initial_errors', array( $this, 'is_spam' ), 10, 2 );
		}

		public function is_spam($errors, $form_data)
		{
			if(!isset($form_data['id'])){
				return $errors;
			}

			$form_id = $form_data['id'];


			if(!Timer::get_instance()->is_human()){
				/*
				 * Add Log Entries
				 */
				$Log_Item = new Log_Item(
					__( 'WPForms Form - JavaScript Validator', 'captcha-for-contact-form-7' ),
					$_POST,
					'spam',
					'JavaScript validation failed in WPForms_Javascript_Validator.php' );
				Log_WordPress::store( $Log_Item );

				$errors[ $form_id ]['footer'] = esc_html__( 'Javascript validation failed.', 'captcha-for-contact-form-7' );
			}

			return $errors;
		}
	}
}