<?php

namespace forge12\contactform7\CF7Captcha {
	if ( ! defined( 'ABSPATH' ) ) {
		exit;
	}

	/**
	 * Class CaptchaGenerator
	 * Generate the custom captcha as an image
	 *
	 * @package forge12\contactform7
	 */
	class CaptchaGenerator {
		/**
		 * @var string List of allowed characters for the captcha
		 */
		private $_allowedCharacters = 'abcdefghjkmnopqrstuvwxyzABCDEFGHJKMNPQRSTUVWXYZ23456789';

		/**
		 * The Captcha string.
		 *
		 * @var string
		 */
		protected $_captcha = '';

		/**
		 * constructor.
		 */
		public function __construct( $length ) {
			$this->generateCaptcha( $length );
		}

		/**
		 * Regenerate Captcha
		 *
		 * @return void
		 */
		public function getReloadButton() {
			$image = plugin_dir_url( __FILE__ ) . 'assets/reload-icon.png';

			return '<a href="javascript:void(0);" class="cf7 captcha-reload" title="' . __( 'Reload Captcha', 'captcha-for-contact-form-7' ) . '"><img style="margin-top:5px;" src="' . $image . '" alt="' . __( 'Reload', 'captcha-for-contact-form-7' ) . '"/></a>';
		}

		/**
		 * Initialize the captcha
		 *
		 * @param $length
		 */
		private function generateCaptcha( $length ) {
			$result = '';
			for ( $i = 0; $i < $length; $i ++ ) {
				$result .= $this->_allowedCharacters[ rand( 0, strlen( $this->_allowedCharacters ) - 1 ) ];
			}

			$this->_captcha = $result;
		}

		/**
		 * Generate the captcha string and return it
		 *
		 * @return string
		 */
		public function get() {
			return $this->_captcha;
		}

		public static function get_additional_form_fields() {
			$additional_form_fields = Timer::get_instance()->get_form_field();

			return $additional_form_fields;
		}
	}
}