<?php

namespace forge12\contactform7\CF7Captcha\core\log {

    if (!defined('ABSPATH')) {
        exit;
    }

    /**
     * Responsible to create the Post Type for the logs
     */
    class Log_WordPress_PostType
    {
        public static function init()
        {
            add_action('init', '\forge12\contactform7\CF7Captcha\core\log\Log_WordPress_PostType::register');
        }

        public static function register()
        {
            $labels = array(
                'name' => _x('Captcha Log', 'Post type general name', 'captcha-for-contact-form-7'),
                'singular_name' => _x('Captcha Log', 'Post type singular name', 'captcha-for-contact-form-7'),
                'menu_name' => _x('Captcha Log', 'Admin Menu text', 'captcha-for-contact-form-7'),
                'name_admin_bar' => _x('Captcha Log', 'Add New on Toolbar', 'captcha-for-contact-form-7'),
                'edit_item' => __('Edit', 'captcha-for-contact-form-7'),
                'view_item' => __('View', 'captcha-for-contact-form-7'),
            );

            $args = array(
                'labels' => $labels,
                'public' => false,
                'publicly_queryable' => false,
                'show_ui' => true,
                'show_in_menu' => false,
                'query_var' => true,
                'capability_type' => 'post',
                'has_archive' => true,
                'hierarchical' => false,
                'menu_position' => null,
                'supports' => array('title', 'editor'),
                'taxonomies' => array('log_status')
            );

            register_post_type('f12_captcha_log', $args);
        }
    }
}