<?php
namespace forge12\contactform7\CF7Captcha {

	use forge12\ui\UI_Manager;
	use forge12\ui\UI_Page_Form;

	if (!defined('ABSPATH')) {
        exit;
    }

    /**
     * Class UILog
     */
    class UI_Log extends UI_Page_Form
    {
        public function __construct(UI_Manager $UI_Manager)
        {
            parent::__construct($UI_Manager, 'log', 'Log Settings', 99);
        }


        protected function on_save($settings)
        {
            foreach ($settings['logs'] as $key => $value) {
                if (isset($_POST[$key])) {
                    $settings['logs'][$key] = (int)$_POST[$key];
                } else {
                    $settings['logs'][$key] = 0;
                }
            }
            return $settings;
        }

        /**
         * Render the license subpage content
         */
        protected function the_content($slug, $page, $settings)
        {
            $settings = $settings['logs'];
            ?>
            <h2>
                <?php _e('Log Settings', 'captcha-for-contact-form-7'); ?>
            </h2>

            <div class="section">
                <div class="option">
                    <div class="label">
                        <label for="enable"><?php _e('Status', 'captcha-for-contact-form-7'); ?></label>
                    </div>
                    <div class="input">
                        <!-- SEPARATOR -->
                        <p style="margin-top:0;"><strong><?php _e('Enable Logging', 'captcha-for-contact-form-7'); ?></strong></p>
                        <input
                                id="enable"
                                type="checkbox"
                                value="1"
                                name="enable"
                            <?php echo isset($settings['enable']) && $settings['enable'] === 1 ? 'checked="checked"' : ''; ?>
                        />
                        <span>
                        <?php _e('If enabled, all submitted forms will be tracked within the log entries.', 'captcha-for-contact-form-7'); ?>
                    </span>
                    </div>
                </div>
            </div>
            <?php
        }

        /**
         * @param $slug
         * @param $page
         *
         * @return void
         */
        protected function the_sidebar($slug, $page)
        {
            return;
        }

        /**
         * @param $settings
         *
         * @return mixed
         */
        public function get_settings($settings)
        {
            $settings['logs'] = array(
                'enable' => 1,
            );

            return $settings;
        }

    }
}